Game = {}
function Game.load()
	math.randomseed(os.time())
	math.random(); math.random(); math.random()
	collider = HC(200, on_collision, collision_stop)
	window = {}
	window.fs = false
	window.width = love.graphics.getWidth()
	window.height = love.graphics.getHeight()
	if window.width / 768 > 1 then
		window.hscale = window.width / 768
	else

	end
	if window.height / 768 > 1 then
		window.vscale = window.height / 768
	else
		window.vscale = 1
	end
	game = {}
	game.difficulty = "easy"
	game.pattern = {}
	game.patternIndex = 0
	for i = 1, 3 do
		game.pattern[i] = love.graphics.newImage("gfx/tile"..i..".png")
	end
	game.color = {
		{r=0, g=0, b=255},
		{r=0, g=200, b=0},
		{r=255, g=0, b=0},
		{r=255, g=255, b=0},
		{r=0, g=255, b=255},
		{r=255, g=0, b=255}
	}
	game.red = 0
	game.green = 0
	game.blue = 255
	game.colorIndex = 1
	game.custom = false
	game.pause = false
	game.customIcon = love.graphics.newImage("gfx/custom.png")
	game.garbage = {}
	game.complete = false
	game.phase = "normal"
	game.normal = true
	game.timer = 0
	game.plus = false
	game.bonus = false
	game.x = false
	game.multiplier = false
	game.perfect = false
	game.result = false
	game.postresult = false
	game.state = "title"
	game.path = "Default levels"
	font = {}
	--font.normal = love.graphics.newImageFont("gfx/nuskool_krome_64x64.png", '!"# '.."'+,.0123456789:;?ABCDEFGHIJKLMNOPQRSTUVWXYZ()")
	--font.normal = love.graphics.newFont("gfx/sofachrome rg.TTF", 45)
	font.normal = love.graphics.newFont("gfx/hydrogen whiskey.ttf", 75)
	font.debug = love.graphics.newFont("gfx/NEXTG___.TTF", 12)
	font.lives = love.graphics.newFont("gfx/NEXTG___.TTF", 34)
	font.bonus = love.graphics.newFont("gfx/NEXTG___.TTF", 14)
	font.dialog = love.graphics.newFont("gfx/mail ray stuff.ttf", 17)
	font.name = love.graphics.newFont("gfx/mail ray stuff.ttf", 35)
	font.popup = love.graphics.newImageFont("gfx/kromasky_16x16.png", "abcdefghijklmnopqrstuvwxyz")
	pointer = {x, y}
	pointer.point = collider:addPoint(0, 0)
	pointer.point.type = "pointer"
	pointer.over = nil
	--pointer.cursor = love.mouse.newCursor("gfx/pointer.png", 0, 0)
	--love.mouse.setCursor(pointer.cursor)
	wall = {}
	wall.left = collider:addRectangle(-32, -1, 31, window.height)
	wall.left.type = "left"
	wall.top = collider:addRectangle(-32, -32, window.width + 32, 31)
	wall.top.type = "top"
	wall.right = collider:addRectangle(window.width, -32, 32, window.height + 32)
	wall.right.type = "right"
	collider:addToGroup("walls", wall.left, wall.top, wall.right)
	collider:setPassive(wall.left, wall.right, wall.top)
	background = wallpaper(game.pattern[1], window.width, window.height)
	brick = {}
	brick.blink = love.graphics.newImage("gfx/brick_blink.png")
	brick.blue = love.graphics.newImage("gfx/brick_blue.png")
	brick.green = love.graphics.newImage("gfx/brick_green.png")
	brick.purple = love.graphics.newImage("gfx/brick_purple.png")
	brick.red = love.graphics.newImage("gfx/brick_red.png")
	brick.yellow = love.graphics.newImage("gfx/brick_yellow.png")
	brick.grey = love.graphics.newImage("gfx/brick_grey.png")
	brick.cyan = love.graphics.newImage("gfx/brick_cyan.png")
	brick.orange = love.graphics.newImage("gfx/brick_orange.png")
	brick.gold = love.graphics.newImage("gfx/brick_gold.png")
	brick.white = love.graphics.newImage("gfx/brick_white.png")
	brick.shadow = love.graphics.newImage("gfx/brick_shadow.png")
	brick.explosion = love.graphics.newImage("gfx/brick_explosion.png")
	brick.count = 0
	stars = {}
	stars.image = love.graphics.newImage("gfx/particleCartoonStar.png")
	stars.particles = {}
	stars.source = love.graphics.newParticleSystem(stars.image, 1600)
	stars.source:setAreaSpread("uniform", 10, 10)
	stars.source:setSpeed(30, 50)
	stars.source:setEmissionRate(10)
	stars.source:setEmitterLifetime(0.3)
	stars.source:setParticleLifetime(0.5, 1)
	stars.source:setColors(255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
	stars.source:setSpread(math.rad(360))
	bling = love.graphics.newParticleSystem(game.customIcon, 1600)
	bling:setAreaSpread("uniform", 100, 20)
	bling:setRotation(0, math.rad(360))
	bling:setSpeed(50, 80)
	bling:setEmissionRate(10)
	--bling:setEmitterLifetime(0.5)
	bling:setParticleLifetime(10, 15)
	bling:setColors(255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
	bling:setSpread(math.rad(360))
	bling:setRelativeRotation(true)
	bling:start()	
	collider:setGhost(wall.left, wall.top, wall.right)
	level = 1
	powers = {}
	power = {}
	power.shadow = love.graphics.newImage("gfx/bonus_shadow.png")
	explosions = {}
	blinks = {}
	labels = {}
end
function Game.update(dt)
	if game.pause == false then
		if game.phase == "normal" then
			Player.update(dt)
			Game.updateField(dt)
			if brick.count == 0 then
				for i, v in ipairs(balls) do
					collider.remove(v.box)
				end
				player.bonus = math.floor(player.bonus)
				Player.reset(paddle.x)
				Game.cleanScreen(true)
				level = level + 1
				game.phase = "teleport"
				TEsound.play("sfx/teleport.ogg")
				player.state = "teleport"
			end
		elseif game.phase == "teleport" then
			game.timer = game.timer + dt
			if game.timer < 1 then
				player.teleport.alpha = player.teleport.alpha + dt * 500
				if player.teleport.alpha > 254 then
					player.teleport.alpha = 255
				end
			elseif game.timer > 1 then
				if game.timer < 1.3 then
					player.teleport.sx = player.teleport.sx + dt * 30
					player.teleport.sy = player.teleport.sy - dt * 3.15
					player.teleport.radius = player.teleport.radius + dt * 200
				elseif game.timer < 1.5 then
					player.teleport.sx  = player.teleport.sx - dt * 50
					player.teleport.radius = player.teleport.radius - dt * 290
				elseif game.timer > 1.7 then
					player.teleport.particle:update(dt)
				end
			end
			if game.timer > 2.3 then
				game.timer = 0
				game.phase = "result"
			end
		elseif game.phase == "result" then
			game.timer = game.timer + dt
			if game.timer > 0.5 then
				if game.plus == false then
					TEsound.play("sfx/jingles_PIZZA16.ogg")
				end
				game.plus = true
			end
			if game.timer > 1 then
				if game.bonus == false then
					TEsound.play("sfx/jingles_PIZZA16.ogg")
				end
				game.bonus = true
			end
			if game.timer > 1.5 then
				if game.x == false then
					TEsound.play("sfx/jingles_PIZZA16.ogg")
				end
				game.x = true
			end
			if game.timer > 2 then
				if game.multiplier == false then
					TEsound.play("sfx/jingles_PIZZA16.ogg")
				end
				game.multiplier = true
			end
			if game.timer > 3 then
				if player.perfect == true then
					if game.perfect == false then
						TEsound.play("sfx/element.ogg")
					end
					game.perfect = true
					player.multiplier = 1000
					bling:update(dt)
				end
			end
			if game.timer > 4 then
				game.plus = false
				game.bonus = false
				game.x = false
				game.multiplier = false
				game.perfect = false
				player.score = player.score + (player.bonus * player.multiplier)
				game.timer = 0
				if player.bonus == 0 then
					player.score = player.score + 500
				end
				game.phase = "postresult"
				bling:reset()
				bling:start()
				if player.bonus == 0 then
					TEsound.play("sfx/nobonus.ogg")
				else
					TEsound.play("sfx/element.ogg")
				end
			end
		elseif game.phase == "postresult" then
			bling:update(dt)
			player.perfect = true
			game.timer = game.timer + dt
			if game.timer > 1 then
				bling:reset()
				bling:start()
				player.state = "intro"
				game.phase = "normal"
				game.timer = 0
				levelload(level)
			end
		end
	else
		pointer.point:moveTo(pointer.x, pointer.y)
	end
end
function Game.draw()
	if game.phase == "normal" then
		Game.drawField()
		Player.draw()
		-- UI Draw ------------------------------------------------------------------------
		love.graphics.setFont(font.lives)
		love.graphics.setColor(0, 0, 0)
		love.graphics.printf(math.floor(player.bonus), 11, 10, 50, "center")
		love.graphics.setFont(font.debug)
		love.graphics.print("bonus", 13, 42)
		love.graphics.setColor(255, 255, 255)
		if player.bonus < 1 then
			love.graphics.setColor(255, 0, 0)
		end
		love.graphics.setFont(font.lives)
		love.graphics.printf(math.floor(player.bonus), 13, 8, 50, "center")
		love.graphics.setFont(font.debug)
		love.graphics.print("bonus", 15, 40)
		love.graphics.setColor(255, 255, 255)
		if player.lives >= 0 then
			--love.graphics.print(player.lives, window.width - 32, 8)
			love.graphics.setFont(font.lives)
			prints(player.lives, 736, 8, 4, 4)
		end
		love.graphics.draw(paddle.icon, 680, 18)
		if player.state == "intro" then
			love.graphics.setFont(font.normal)
			--love.graphics.printf("LEVEL "..level, 0, 350, window.width, "center")
			prints("LEVEL "..level, 0, 350, 8, 8, window.width, "center")
		end
		love.graphics.setFont(font.normal)
		prints(player.score, 0, 10, 8, 8, window.width, "center")
		--love.graphics.printf(player.score, 0, 10, window.width, "center")
	elseif game.phase == "teleport" then
		if game.timer < 1.7 then
			if game.timer < 1 then
				love.graphics.draw(paddle.normal, paddle.x, paddle.y, 0 , 1, 1, 52, 12)
			end
			love.graphics.setColor(255, 255, 255, player.teleport.alpha)
			love.graphics.draw(player.teleport.paddle, paddle.x, paddle.y, 0, player.teleport.sx, player.teleport.sy, 52, 12)
			love.graphics.circle("fill", paddle.x, paddle.y, player.teleport.radius)
			love.graphics.setColor(255, 255, 255)
		else
			love.graphics.draw(player.teleport.particle, paddle.x, paddle.y)
		end
		love.graphics.setFont(font.normal)
		--love.graphics.printf(player.score, 0, 10, window.width, "center")
		prints(player.score, 0, 10, 8, 8, window.width, "center")
	elseif game.phase == "result" then
		love.graphics.setFont(font.normal)
		if game.plus == true then
			--love.graphics.printf("+", 0, 110, window.width, "center")
			prints("+", 0, 110, 8, 8, window.width, "center")
		end
		if game.bonus == true then
			--love.graphics.printf(player.bonus, 0, 210, window.width, "center")
			prints(player.bonus, 0, 210, 8, 8, window.width, "center")
		end
		if game.x == true then
			--love.graphics.printf("X", 0, 310, window.width, "center")
			prints("X", 0, 310, 8, 8, window.width, "center")
		end
		if game.multiplier == true then
			--love.graphics.printf(player.multiplier, 0, 410, window.width, "center")
			prints(player.multiplier, 0, 410, 8, 8, window.width, "center")
		end
		if game.perfect == true then
			love.graphics.draw(bling, 400, 542)
			--love.graphics.printf("PERFECT", 0, 510, window.width, "center")
			prints("PERFECT", 0, 510, 8, 8, window.width, "center")
		end
		love.graphics.setFont(font.normal)
		--love.graphics.printf(player.score, 0, 10, window.width, "center")
		prints(player.score, 0, 10, 8, 8, window.width, "center")
	elseif game.phase == "postresult" then
		if player.bonus > 0 then
			love.graphics.draw(bling, 400, 42)
		end
		love.graphics.setFont(font.normal)
		prints(player.score, 0, 10, 8, 8, window.width, "center")
		--love.graphics.printf(player.score, 0, 10, window.width, "center")
	end
	if game.pause == true then
		love.graphics.setColor(0, 32, 64, 128)
		love.graphics.rectangle("fill", 0, 0, 768, 768)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(editor.dialog.panel, 284, 334)
		love.graphics.draw(editor.dialog.buttonDefault, 290, 395)
		love.graphics.draw(editor.dialog.buttonDefault, 386, 395)
		if game.pointer == "yes" then
			love.graphics.draw(editor.dialog.buttonSelected, 290, 395)
		elseif game.pointer == "no" then
			love.graphics.draw(editor.dialog.buttonSelected, 386, 395)
		end
		love.graphics.setFont(font.dialog)
		love.graphics.setColor(128, 128, 128)
		love.graphics.printf("Pause.\nDo you want to quit?", 284, 340, 200, "center")
		love.graphics.printf("YES", 290, 398, 90, "center")
		love.graphics.printf("NO", 386, 398, 90, "center")
		love.graphics.setColor(255, 255, 255)
	end
end
function Game.mouseClicked(x, y, btn)
	if game.pause == true then
		if game.pointer == "yes" then
			collider:setGhost(menu.yes, menu.no, pointer.point)
			game.pause = false
			Game.reset("title")
			Game.cleanScreen(true)
			love.mouse.setVisible(true)
			love.mouse.setGrabbed(false)
		elseif game.pointer == "no" then
			collider:setGhost(menu.yes, menu.no, pointer.point)
			Game.pause(false)
			game.pause = false
			love.mouse.setVisible(false)
			love.mouse.setGrabbed(true)
		end
	else
		if btn == "l" then
			if paddle.mode == "laser" then
				Player.shoot(paddle.x, paddle.y)
			end
			if player.state == "normal" then
				player.lock = false
				player.timer = 0
				for i, v in ipairs(balls) do
					v.box.lock = false
				end
			end
		end
	end
end
function Game.keypressed(key)
	if key == "escape" then
		if game.pause == false then
			game.pause = true
			Game.pause(true)
			collider:setSolid(menu.yes, menu.no, pointer.point)
			love.mouse.setVisible(true)
			love.mouse.setGrabbed(false)
		elseif game.pause == true then
			game.pause = false
			Game.pause(false)
			collider:setGhost(menu.yes, menu.no, pointer.point)
			love.mouse.setVisible(false)
			love.mouse.setGrabbed(true)
		end
	end
end
function Game.bounce(b, object, dx, dy)
	local x, y = object:center()
	if object.type == "brick" then
		if Z == false then
			b.combo = b.combo + 1
			Game.addParticles(b.x + dx, b.y + dy)
			if ball.mode == "super" then
				TEsound.play("sfx/brick break.ogg")
				object.hp = 0
			else
				if y < b.y then -- ball is under the brick.
					if b.x - x >= 32 then --ball is on the right
						b.angle = 180 - b.angle
						b.x = b.x + dx
						b.y = b.y + dy
					elseif b.x - x <= -32 then --ball is on the left
						b.angle = 180 - b.angle
						b.x = b.x - dx
						b.y = b.y + dy
					else --ball is fully under
						b.angle = 0 - b.angle
						b.y = b.y + dy
					end
				else -- ball is over the brick
					if b.x - x >= 32 then --ball is on the right
						b.angle = 180 - b.angle
						b.x = b.x + dx
						b.y = b.y - dy
					elseif b.x - x <= -32 then --ball is on the left
						b.angle = 180 - b.angle
						b.x = b.x - dx
						b.y = b.y - dy
					else --ball is fully over
						b.angle = 0 - b.angle
						b.y = b.y - dy
					end
				end
				Game.blink(object:center())
				if object.hp > 0 then
					object.hp = object.hp - 1
					if object.hp == 0 then
						TEsound.play("sfx/brick break.ogg")
					else
						TEsound.play("sfx/brick bump.ogg")
					end
					if object.hp < 0 then
						object.hp = 0
					end
				else
					TEsound.play("sfx/brick bump.ogg")
				end
			end
			Z = true
		end
	elseif object.type == "paddle" then
		b.combo = 0
		b.distance = b.x - paddle.x
		TEsound.play("sfx/normal bump.ogg")
		b.angle = math.deg(math.atan2(b.y - y, b.x - x))
		b.y = 716
		if paddle.mode == "glue" then
			b.lock = true
		end
	elseif object.type == "left" then
		if b.x - 11 < 0 then
			b.x = 11
		end
		b.combo = b.combo + 1
		TEsound.play("sfx/normal bump.ogg")
		b.angle = 180 - b.angle
	elseif object.type == "top" then
		if b.y - 11 < 0 then
			b.y = 11
		end
		b.combo = b.combo + 1
		TEsound.play("sfx/normal bump.ogg")
		b.angle = -b.angle
	elseif object.type == "right" then
		if b.x + 11 > 768 then
			b.x = 757
		end
		b.x = b.x - dx
		b.combo = b.combo + 1
		TEsound.play("sfx/normal bump.ogg")
		b.angle = 180 - b.angle
	end
end
function Game.catch(object, b)
	if object.type == "slow" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		Game.label("slow", paddle.x, 705, 255, 121, 1)
		object.catch = true
		TEsound.play("sfx/slow.ogg")
		ball.speed = ball.speed - 1
		if ball.speed <= ball.limit then
			ball.speed = ball.limit
		end
		Player.setScale()
	elseif object.type == "glue" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		object.catch = true
		if paddle.mode ~= "glue" then
			Game.label("catch", paddle.x, 705, 172, 213, 78)
			TEsound.play("sfx/glue.ogg")
			paddle.ox = 52
			paddle.oy = 12
			paddle.image = paddle.glue
			Player.setScale()
			paddle.image = paddle.glue
			paddle.mode = "glue"
			paddle.oyb = 0
			paddle.shadow = paddle.normalShadow
		end
	elseif object.type == "super" then
		player.score = player.score + 5
		object.catch = true
		if ball.mode ~= "super" then
			Game.label("megaball", paddle.x, 705, 138, 99, 155)
			TEsound.play("sfx/super.ogg")
			ball.image = ball.super
			ball.mode = "super"
			Player.setScale()
		end
	elseif object.type == "life" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		Game.label("player", paddle.x, 705, 204, 204, 204)
		TEsound.play("sfx/life.ogg")
		Player.setScale()
		object.catch = true
		player.lives = player.lives + 1
		Player.setScale()
	elseif object.type == "multi" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		object.catch = true
		if ball.count < 8 then
			Game.label("disruption", paddle.x, 705, 74, 191, 240)
			TEsound.play("sfx/multi.ogg")
			local h = 768
			for i, v in ipairs(balls) do
				if v.box.y < h then
					h = i
				end
			end
			local angle = balls[h].box.angle
			local x = balls[h].box.x
			local y = balls[h].box.y
			Player.createBall(angle - 10, x, y, false)
			if ball.count < 7 then
				Player.createBall(angle + 10, x, y, false)
			end
		Player.setScale()
		end
	elseif object.type == "laser" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		object.catch = true
		if paddle.mode ~= "laser" then
			Game.label("laser", paddle.x, 705, 242, 55, 55)
			TEsound.play("sfx/laser catch.ogg")
			for i, v in ipairs(balls) do
				v.box.lock = false
			end
			paddle.ox = 52
			paddle.oy = 17
			paddle.image = paddle.laser
			Player.setScale()
			paddle.image = paddle.laser
			paddle.mode = "laser"
			paddle.oyb = 0
			paddle.shadow = paddle.laserShadow
		end
	elseif object.type == "large" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		for i, v in ipairs(balls) do
			v.box.lock = false
		end
		object.catch = true
		if paddle.mode ~= "large" then
			Game.label("enlarge", paddle.x, 705, 100, 120, 242)
			TEsound.play("sfx/large.ogg")
			paddle.ox = 77
			paddle.oy = 12
			paddle.image = paddle.large
			paddle.mode = "large"
			Player.setScale()
			paddle.oyb = -4
			paddle.shadow = paddle.largeShadow
		end
	elseif object.type == "small" then
		player.score = player.score + 5
		ball.mode = "normal"
		ball.image = ball.normal
		for i, v in ipairs(balls) do
			v.box.lock = false
		end
		object.catch = true
		if paddle.mode ~= "small" then
			Game.label("reduce", paddle.x, 705, 85, 85, 85)
			TEsound.play("sfx/small.ogg")
			paddle.ox = 26
			paddle.oy = 12
			paddle.image = paddle.small
			Player.setScale()
			paddle.mode = "small"
			paddle.oyb = 4
			paddle.shadow = paddle.smallShadow
		end
	end
end
function Game.reset(p)
	for i, v in ipairs(bricks) do
		if v ~= 0 then
			collider:remove(v.box)
		end
	end
	for i, v in ipairs(powers) do
		collider:remove(v.box)
	end
	powers = {}
	love.mouse.setVisible(true)
	love.mouse.setGrabbed(false)
	stars.source:reset()
	player.perfect = true
	Player.reset(300)
	player.state = "intro"
	game.state = p
	game.complete = false
	if game.difficulty == "easy" then
		player.lives = 5
	elseif game.difficulty == "normal" then
		player.lives = 3
	elseif game.difficulty == "hard" then
		player.lives = 1
	end	
	if p == "title" then
		level = 1
		player.score = 0
		player.grandSlam = true
		player.oneLife = true
		player.continue = false
	end
	if p ~= "game" then
		collider:setSolid(button.start, button.edit, button.exit, button.load, button.options, pointer.point)
		collider:setGhost(paddle.box, wall.left, wall.top, wall.right)
	end
	background = wallpaper(game.pattern[1], 768, 768)
	game.red = game.color[1].r
	game.green = game.color[1].g
	game.blue = game.color[1].b
	game.patternIndex = 0
	game.colorIndex = 1
end
function Game.pause(switch)
	if switch == true then
		for i, v in ipairs(bricks) do
			if v ~= 0 then
				collider:setGhost(v.box)
			end
		end
		for i, v in ipairs(powers) do
			if v.y < 600 then
				collider:setGhost(v.box)
			end
		end
		for i, v in ipairs(lasers) do
			collider:setGhost(v.box)
		end
	elseif switch == false then
		for i, v in ipairs(bricks) do
			if v ~= 0 then
				collider:setSolid(v.box)
			end
		end
		for i, v in ipairs(powers) do
			if v.y < 600 then
				collider:setSolid(v.box)
			end
		end
		for i, v in ipairs(lasers) do
			collider:setSolid(v.box)
		end
	end
end
function Game.updateField(dt)
	for i, v in ipairs(bricks) do
		if v ~= 0 then
			if v.box.hp == 0 then
				if ball.mode == "super" then
					Game.explode(v.x, v.y)
				end
				if v.brick ~= "gold" then
					player.score = player.score + v.value
				end
				collider:remove(v.box)
				table.remove(bricks, i)
				if v.brick == "gold" then
					brick.count = brick.count + 1
				end
				brick.count = brick.count - 1
				if brick.count > 0 then
					if v.bonus ~= "nothing" then
						local t = {}
						t.x = v.x + 32
						t.y = v.y + 16
						t.angle = 0
						t.box = collider:addRectangle(t.x, t.y, 46, 46)
						t.box.type = v.bonus
						t.box.catch = false
						collider:addToGroup("bricks", t.box)
						table.insert(powers, t)
					end
				end
			end
		end
	end
	for i, v in ipairs(powers) do
		if v.box.catch == true then
			table.insert(game.garbage, v.box)
		end
		v.y = v.y + dt * 100
		v.angle = v.angle + dt
		v.box:moveTo(v.x, v.y)
		if v.y > 770 then
			collider:remove(v.box)
			table.remove(powers, i)
		end
	end
	for i, v in ipairs(game.garbage) do
		collider:remove(v)
	end
	for i, v in ipairs(explosions) do
		v.anim:update(dt)
		if v.anim:getCurrentFrame() == 10 then
			table.remove(explosions, i)
		end
	end
	for i, v in ipairs(blinks) do
		v.alpha = v.alpha - dt * 1200
		if v.alpha < 1 then
			v.alpha = 0
			table.remove(blinks, i)
		end
	end
	for i, v in ipairs(labels) do
		v.y = v.y - dt * 20
		v.timer = v.timer + dt
		if v.timer > 0.5 then
			v.alpha = v.alpha - dt * 1000
			if v.alpha < 1 then
				table.remove(labels, i)
			end
		end
	end
	for i, v in ipairs(stars.particles) do
		v.particles:update(dt)
		if v.particles:isActive() == false then
			table.remove(stars.particles, i)
		end
	end
end
function Game.drawField()
	for i, v in ipairs(bricks) do
		if v ~= 0 then
			love.graphics.draw(brick.shadow, v.x + 8, v.y + 8)
			if v.brick == "blue" then
				love.graphics.draw(brick.blue, v.x, v.y)
			elseif v.brick == "red" then
				love.graphics.draw(brick.red, v.x, v.y)
			elseif v.brick == "green" then
				love.graphics.draw(brick.green, v.x, v.y)
			elseif v.brick == "yellow" then
				love.graphics.draw(brick.yellow, v.x, v.y)
			elseif v.brick == "purple" then
				love.graphics.draw(brick.purple, v.x, v.y)
			elseif v.brick == "grey" then
				love.graphics.draw(brick.grey, v.x, v.y)
			elseif v.brick == "orange" then
				love.graphics.draw(brick.orange, v.x, v.y)
			elseif v.brick == "cyan" then
				love.graphics.draw(brick.cyan, v.x, v.y)
			elseif v.brick == "white" then
				love.graphics.draw(brick.white, v.x, v.y)
			elseif v.brick == "gold" then
				love.graphics.draw(brick.gold, v.x, v.y)
			end
		end
	end
	for i, v in ipairs(blinks) do
		love.graphics.setColor(255, 255, 255, v.alpha)
		love.graphics.draw(brick.blink, v.x, v.y)
		love.graphics.setColor(255, 255, 255, 255)
	end
	for i, v in ipairs(explosions) do
		v.anim:draw(v.x, v.y)
	end
	for i, v in ipairs(powers) do
		if v.box.catch == false then
			love.graphics.draw(power.shadow, v.x + 4, v.y + 4, v.angle, 1, 1, 24, 24)
			if v.box.type == "glue" then
				love.graphics.draw(editor.bonus.glue.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("C", v.x -4, v.y -8)
			elseif v.box.type == "super" then
				love.graphics.draw(editor.bonus.super.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("M", v.x -4, v.y -8)
			elseif v.box.type == "slow" then
				love.graphics.draw(editor.bonus.slow.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("S", v.x -4, v.y -8)
			elseif v.box.type == "life" then
				love.graphics.draw(editor.bonus.life.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("P", v.x -4, v.y -8)
			elseif v.box.type == "multi" then
				love.graphics.draw(editor.bonus.multi.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("D", v.x -4, v.y -8)
			elseif v.box.type == "laser" then
				love.graphics.draw(editor.bonus.laser.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("L", v.x -4, v.y -8)
			elseif v.box.type == "large" then
				love.graphics.draw(editor.bonus.large.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("E", v.x -4, v.y -8)
			elseif v.box.type == "small" then
				love.graphics.draw(editor.bonus.small.image, v.x, v.y, v.angle, 1, 1, 24, 24)
				printbonus("R", v.x -4, v.y -8)
			end
		end
	end
	for i, v in ipairs(labels) do
		love.graphics.setFont(font.popup)
		love.graphics.setColor(v.r, v.g, v.b, v.alpha)
		love.graphics.print(v.text, v.x, v.y)
		love.graphics.setColor(255, 255, 255, 255)
	end
	for i, v in ipairs(stars.particles) do
		love.graphics.draw(v.particles, v.x, v.y)
	end
end
function Game.explode(x, y)
	local t = {}
	--t.anim = newAnimation(brick.explosion, 96, 48, 0.03, 0)
	t.anim = newAnimation(brick.explosion, 64, 32, 0.03, 0)
	t.x = x
	t.y = y
	table.insert(explosions, t)
end
function Game.blink(x, y)
	t = {}
	t.x = x - 32
	t.y = y - 16
	t.alpha = 255
	table.insert(blinks, t)
end
function Game.cleanScreen(complete)
	if complete == true then
		for i, v in ipairs(bricks) do
			if v ~= 0 then
				collider:remove(v.box)
			end
		end
	end
	for i, v in ipairs(lasers) do
		collider:remove(v.box)
	end
	lasers = {}
	for i, v in ipairs(powers) do
		collider:remove(v.box)
	end
	powers = {}
	explosions = {}
	blinks = {}
	labels = {}
end
function Game.label(text, x, y, r, g, b)
	local t = {}
	t.x = x - 52
	t.y = y
	t.r = r
	t.g = g
	t.b = b
	t.text = text
	t.alpha = 255
	t.timer = 0
	table.insert(labels, t)
end
function Game.addParticles(x, y)
	local t = {}
	t.x = x
	t.y = y
	t.particles = stars.source:clone()
	t.particles:start()
	table.insert(stars.particles, t)
end
function Game.checkScore()
	if game.custom == false then
		local Q = false
		for i, v in ipairs(scores.best) do
			if player.score > v.value then
				scores.type = "high"
				scores.input = true
				scores.index = i
				Q = true
				break
			end
		end
		for i, v in ipairs(scores.worst) do
			if player.score < v.value then
				scores.type = "low"
				scores.input = true
				scores.index = i
				Q = true
				break
			end
		end
		if Q == true then
			Game.reset("score")
		else
			Game.reset("title")
		end
	else
		Game.reset("title")
	end
end