Player = {}
function Player.load()
	player = {}
	player.score = 0
	player.buffer = 0.2
	player.lives = 3
	player.state = "intro"
	player.alive = true
	player.lock = false
	player.timer = 0
	player.bonus = 0
	player.multiplier = 100
	player.perfect = true
	player.oneLife = true
	player.grandSlam = true
	player.continue = false
	local image = love.graphics.newImage("gfx/particleCartoonStar.png")
	player.teleport = {}
	player.teleport.sx = 1
	player.teleport.sy = 1
	player.teleport.radius = 0
	player.teleport.alpha = 0
	player.teleport.paddle = love.graphics.newImage("gfx/paddle_white.png")
	player.teleport.particle = love.graphics.newParticleSystem(image, 1000)
	player.teleport.particle:setAreaSpread("uniform", 10, 10)
	player.teleport.particle:setSpeed(50, 80)
	player.teleport.particle:setEmissionRate(10)
	player.teleport.particle:setEmitterLifetime(0.5)
	player.teleport.particle:setParticleLifetime(10, 15)
	player.teleport.particle:setColors(255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
	player.teleport.particle:setSpread(math.rad(360))
	player.teleport.particle:start()
	paddle = {}
	paddle.explosion = {}
	image = love.graphics.newImage("gfx/explosion - big.png")
	paddle.explosion[1] = newAnimation(image, 40, 40, 0.05, 0)
	paddle.explosion[1]:setMode("once")
	image = love.graphics.newImage("gfx/explosion - medium.png")
	paddle.explosion[2] = newAnimation(image, 20, 20, 0.05, 0)
	paddle.explosion[2]:setMode("once")
	image = love.graphics.newImage("gfx/explosion - small.png")
	paddle.explosion[3] = newAnimation(image, 20, 20, 0.05, 0)
	paddle.explosion[3]:setMode("once")
	paddle.mode = "normal"
	paddle.icon = love.graphics.newImage("gfx/paddle_icon.png")
	paddle.normal = love.graphics.newImage("gfx/paddle_normal.png")
	paddle.normalShadow = love.graphics.newImage("gfx/paddle_normal_shadow.png")
	paddle.glue = love.graphics.newImage("gfx/paddle_glue.png")
	paddle.large = love.graphics.newImage("gfx/paddle_large.png")
	paddle.largeShadow = love.graphics.newImage("gfx/paddle_large_shadow.png")
	paddle.laser = love.graphics.newImage("gfx/paddle_laser.png")
	paddle.laserShadow = love.graphics.newImage("gfx/paddle_laser_shadow.png")
	paddle.illusion = love.graphics.newImage("gfx/paddle_illusion.png")
	paddle.small = love.graphics.newImage("gfx/paddle_small.png")
	paddle.smallShadow = love.graphics.newImage("gfx/paddle_small_shadow.png")
	paddle.image = paddle.normal
	paddle.shadow = paddle.normalShadow
	paddle.beam = love.graphics.newImage("gfx/laser.png")
	paddle.beamGlow = love.graphics.newImage("gfx/laser_glow.png")
	paddle.beamAlpha = 0
	paddle.x = 300
	paddle.y = 768 - 32
	paddle.ox = 52
	paddle.oy = 12
	paddle.oyb = 0
	paddle.box = collider:addPolygon(12, 0, 92, 0, 104, 12, 0, 12)
	paddle.box.type = "paddle"
	ball = {}
	ball.guide = love.graphics.newImage("gfx/arrow.png")
	ball.count = 0
	ball.mode = "normal"
	ball.timer = 0
	ball.normal = love.graphics.newImage("gfx/ballGrey.png")
	ball.super = love.graphics.newImage("gfx/ballBlue.png")
	ball.image = ball.normal
	ball.shadow = love.graphics.newImage("gfx/ballShadow.png")
	ball.speed = 5
	ball.limit = 5
	ball.step = 7
	balls = {}
	lasers = {}
	collider:addToGroup("walls", paddle.box)
	collider:setGhost(paddle.box)
end
function Player.update(dt)
	for i, v in ipairs(balls) do
		if v.box.combo > 100 then
			v.box.angle = math.random(45, 135)
		end
		if v.box.lock == true then
			if game.difficulty == "easy" then
				if v.guide.alpha > 0 then
					v.guide.x = v.box.x + math.cos(math.rad(v.box.angle)) * v.guide.distance
					v.guide.y = v.box.y + math.sin(math.rad(v.box.angle)) * v.guide.distance
					v.guide.distance = v.guide.distance + dt * 230
					v.guide.alpha = v.guide.alpha - dt * 500
					if v.guide.alpha < 0 then
						v.guide.alpha = 0
					end
				else
					v.guide.distance = 20
					v.guide.alpha = 255
					v.guide.x = v.box.x + math.cos(math.rad(v.box.angle)) * v.guide.distance
					v.guide.y = v.box.y + math.sin(math.rad(v.box.angle)) * v.guide.distance
				end
			end
			if v.box .angle > 0 then
				if v.box.angle < 10 then
					v.box.angle = 10
				elseif v.box.angle > 170 then
					v.box.angle = 170
				end
			elseif v.box.angle < 0 then
				if v.box.angle > -10 then
					v.box.angle = -10
				elseif v.box.angle < -170 then
					v.box.angle = -170
				end
			end
			player.lock = true
			v.box.y = 716
			v.box.x = paddle.x + v.box.distance
		else
			v.guide.distance = 20
			v.guide.alpha = 255
			v.guide.x = v.box.x + math.cos(math.rad(v.box.angle)) * v.guide.distance
			v.guide.y = v.box.y + math.sin(math.rad(v.box.angle)) * v.guide.distance
			if v.box.combo == 0 then
				if v.box.angle > 0 then
					if v.box.angle > 170 then
						v.box.angle = 170
					elseif v.box.angle < 10 then
						v.box.angle = 10
					end
				else
					if v.box.angle < -170 then
						v.box.angle = -170
					elseif v.box.angle > -10 then
						v.box.angle = -10
					end
				end
			end
			v.box.x = v.box.x + math.cos(math.rad(v.box.angle)) * ball.speed
			v.box.y = v.box.y + math.sin(math.rad(v.box.angle)) * ball.speed
			if v.box.y > 768 then
				ball.count = ball.count - 1
				if ball.count < 1 then
					player.state = "death"
					player.perfect = false
					player.oneLife = false
					Game.cleanScreen(false)
					if game.state == "game" then 
						player.lives = player.lives - 1
						if player.lives < 0 then
							TEsound.play("sfx/jingles_HIT15.ogg")
						else
							TEsound.play("sfx/jingles_HIT03.ogg")
						end
					end
				end
				collider:remove(v.box)
				table.remove(balls, i)
			end
		end
		v.box:moveTo(v.box.x, v.box.y)
	end
	for i, v in ipairs(lasers) do
		v.y = v.y - dt * 500
		v.box:moveTo(v.x, v.y)
		if v.box.hit == true then
			TEsound.play("sfx/brick bump.ogg")
			collider:remove(v.box)
			table.remove(lasers, i)
		elseif v.y < -50 then
			collider:remove(v.box)
			table.remove(lasers, i)
		end
	end
	if player.state == "normal" then
		if player.lock == true then
			player.timer = player.timer + dt
			if player.timer > 3 then
				player.timer = 0
				player.lock = false
				for i, v in ipairs(balls) do
					v.box.lock = false
				end
			end
		end
		ball.timer = ball.timer + dt
		if ball.timer > ball.step then
			ball.timer = 0
			ball.speed = ball.speed + 0.5
			if ball.speed < ball.limit then
				ball.speed = ball.limit
			end
		end
		player.bonus = player.bonus - dt
		if player.bonus < 0 then
			player.bonus = 0
			player.grandSlam = false
		end
		paddle.x = pointer.x
		if paddle.x < paddle.ox then
			paddle.x = paddle.ox
		elseif paddle.x > 768 - paddle.ox then
			paddle.x = 768 - paddle.ox
		end
		paddle.box:moveTo(paddle.x, paddle.y - paddle.oyb)
		if paddle.mode == "laser" then
			player.buffer = player.buffer + dt
			if player.buffer > 0.2 then
				player.buffer = 0.2
			elseif player.buffer < 0.2 then
				paddle.beamAlpha = paddle.beamAlpha - dt * 2000
				if paddle.beamAlpha < 1 then
					paddle.beamAlpha = 0
				end
			end
		end
	elseif player.state == "intro" then
		game.timer = game.timer + dt
		if game.timer > 1.5 then
			game.timer = 0
			player.state = "normal"
		end
	elseif player.state == "death" then
		for i, v in ipairs(paddle.explosion) do
			v:update(dt)
		end
		game.timer = game.timer + dt
		if game.timer > 2 then
			for i, v in ipairs(paddle.explosion) do
				v:reset()
				v:play()
			end
			game.timer = 0
			if player.lives < 0 then
				collider:setSolid(continue.yes, continue.no, pointer.point)
				love.mouse.setVisible(true)
				game.state = "game over"
				TEsound.play("sfx/countdown.ogg")
			else
				Player.reset(300)
				TEsound.play("sfx/jingles_PIZZA12.ogg")
				player.state = "intro"
			end
		end
	end
end
function Player.draw()
	if player.state == "death" then
		if game.timer < 0.2 then
			love.graphics.draw(paddle.shadow, paddle.x, paddle.y, 0, 1, 1, paddle.ox - 16, paddle.oy - 16)
			love.graphics.draw(paddle.image, paddle.x, paddle.y, 0, 1, 1, paddle.ox, paddle.oy)
		end
	else
		love.graphics.draw(paddle.shadow, paddle.x, paddle.y, 0, 1, 1, paddle.ox - 16, paddle.oy - 16)
		love.graphics.draw(paddle.image, paddle.x, paddle.y, 0, 1, 1, paddle.ox, paddle.oy)
	end
	for i, v in ipairs(lasers) do
		love.graphics.draw(paddle.beam, v.x, v.y, 0, 1, 1, 4, 27)
	end
	
	for i, v in ipairs(balls) do
		love.graphics.draw(ball.shadow, v.box.x, v.box.y, 0, 1, 1, 0, 0)
		if game.difficulty == "easy" then
			if v.box.lock == true then
				love.graphics.setColor(255, 255, 255, v.guide.alpha)
				love.graphics.draw(ball.guide, v.guide.x, v.guide.y, math.rad(v.box.angle), 1, 1, 27, 15.5)
				love.graphics.setColor(255, 255, 255, 255)
			end
		end
	end
	for i, v in ipairs(balls) do
		love.graphics.draw(ball.image, math.floor(v.box.x), math.floor(v.box.y), 0, 1, 1, 11, 11)
	end
	if paddle.mode == "laser" then
		love.graphics.setColor(255, 255, 255, paddle.beamAlpha)
		love.graphics.draw(paddle.beamGlow, paddle.x, paddle.y, 0, 1, 1, paddle.ox, 27)
		love.graphics.setColor(255, 255, 255, 255)
	end
	if player.state == "death" then
		paddle.explosion[2]:draw(paddle.x - 30, paddle.y - 20)
		paddle.explosion[2]:draw(paddle.x + 10, paddle.y - 20)
		paddle.explosion[2]:draw(paddle.x - 30, paddle.y)
		paddle.explosion[2]:draw(paddle.x + 10, paddle.y)
		paddle.explosion[3]:draw(paddle.x - 10, paddle.y - 8)
		paddle.explosion[3]:draw(paddle.x, paddle.y - 8)
		paddle.explosion[1]:draw(paddle.x - 20, paddle.y - 18)
		paddle.explosion[1]:draw(paddle.x + 20, paddle.y - 18)
		paddle.explosion[1]:draw(paddle.x - 60, paddle.y - 18)
	end
end
function Player.reset(x)
	paddle.x = x
	paddle.y = 768- 32
	for i, v in ipairs(balls) do
		collider:remove(v.box)
	end
	balls = {}
	for i, v in ipairs(lasers) do
		collider:remove(v.box)
	end
	lasers = {}
	stars.particles = {}
	ball.count = 0
	ball.mode = "normal"
	if game.mode == "editor" then
		paddle.x = 300
	end
	Player.createBall(-30, paddle.x + 80, 716, true)
	ball.timer = 0
	if game.difficulty == "easy" then
		ball.speed = 5
		ball.limit = 5
		ball.step = 7
	elseif game.difficulty == "normal" then
		ball.speed = 7
		ball.limit = 7
		ball.step = 6
	elseif game.difficulty == "hard" then
		ball.speed = 9
		ball.limit = 9
		ball.step = 4
	end
	ball.image = ball.normal
	paddle.image = paddle.normal
	paddle.shadow = paddle.normalShadow
	paddle.mode = "normal"
	if game.mode ~= "test" then
		player.state = "intro"
	end
	Player.setScale()
	player.multiplier = 100
	player.Timer = 0
	game.timer = 0
	paddle.ox = 52
	paddle.oy = 12
	paddle.oyb = 0
	player.teleport.sx = 1
	player.teleport.sy = 1
	player.teleport.alpha = 0
	player.teleport.radius = 0
	player.teleport.particle:reset()
	player.teleport.particle:start()
end
function Player.createBall(angle, x, y, lock)
	if angle > 0 then
		if angle < 3 then
			angle = 10
		elseif angle > 178 then
			if angle < 183 then
				angle = 190
			end
		end
	else
		if angle > -3 then
			angle = -10
		elseif angle < -178 then
			if angle > -183 then
				angle = -190
			end
		end
	end
	local b = {}
	b.box = collider:addCircle(paddle.x + 80, 716, 11)
	b.box.x = x
	b.box.y = y
	b.box.angle = angle
	b.box.type = "ball"
	b.box.name = "regular"
	b.box.distance = 20
	b.box.lock = lock
	b.box.combo = 1
	b.box.guide = false
	b.guide = {}
	b.guide.x = x + math.cos(math.rad(angle)) * 20
	b.guide.y = y + math.sin(math.rad(angle)) * 20
	b.guide.distance = 20
	b.guide.alpha = 255
	collider:addToGroup("balls", b.box)
	table.insert(balls, b)
	ball.count = ball.count + 1
end
function Player.shoot(x, y)
	if player.buffer == 0.2 then
		TEsound.play("sfx/laser.ogg")
		paddle.beamAlpha = 255
		local t = {}
		t.x = x - 31
		t.y = y - 9
		t.box = collider:addRectangle(t.x, y, 9, 54)
		t.box.type = "bullet"
		t.box.hit = false
		table.insert(lasers, t)
		t = {}
		t.x = x + 28
		t.y = y - 9
		t.box = collider:addRectangle(t.x, y, 9, 54)
		t.box.type = "bullet"
		t.box.hit = false
		table.insert(lasers, t)
		player.buffer = 0
	end
end
function Player.hit(beam, object)
	local x, y = object:center()
	Game.blink(x, y)
	Game.addParticles(x, y + 16)
	if object.hp > 0 then
		object.hp = object.hp - 1
		if object.hp < 0 then
			object.hp = 0
		end
		beam.hit = true
	elseif object.type == "brick" then
		beam.hit = true
	end
end
function Player.setScale()
	if paddle.mode == "small" then
		paddle.mode = "normal"
		paddle.image = paddle.normal
		paddle.ox = 52
		paddle.oy = 12
	end
	local x1,y1, x2,y2 = paddle.box:bbox()
	local w = x2 - x1
	if w < 0 then
		w = -w
	end
	local i = paddle.image:getWidth()
	local s = i / w
	paddle.box:scale(s)
end